squaresComp :: [Int] -> [Int]
squaresComp xs  =  [ x*x | x <- xs ]

squaresRec :: [Int] -> [Int]
squaresRec []      =  []
squaresRec (x:xs)  =  x*x : squaresRec xs

squaresMap :: [Int] -> [Int]
squaresMap xs  =  map sqr xs
  where
  sqr x  =  x*x

prop_squares :: [Int] -> Bool
prop_squares xs  =  squaresComp xs == squaresRec xs && squaresRec xs == squaresMap xs
